;;; Studio Tecnico Arch. Giuseppe Conte  
;;; via Roma, 28
;;; 72026 - San Pancrazio Salentino (BR) - Italy
;;;
;;; Plugin  : draw-circle-point.scm
;;; Author  : Arch. Giuseppe Conte 
;;; Date    : 27 settembre 2002 - San Pancrazio Salentino
;;; Revision: 11 giugno 2006
;;; 					10 dicembre 2007 update to TinyScheme
;;; Version : 2.4.1
;;; Last version at: http://xoomer.alice.it/lwcon/gimp/script-fu/draw-circle-poin.htm
;;; Help guide at  : http://xoomer.alice.it/lwcon/gimp/script-fu/draw-circle-poin.htm
;;; Required : Gimp 2.4.1 or last
;;;
;;; Description: 
;;; Draw active brush in circle.
;;; -----------------------------------------------------------------------------
;;;
;;; License:
;;; This program is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 2 of the License, or
;;; (at your option) any later version.
;;; 
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;; 
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

;;; Define the function:

(define (script-fu-draw-circle-point inImage inLayer dx dy Radius Points )
	(let* ( (angolo)
					(arco)
					(alfa)
					(gcount)
					(npoint)
					(segment)
					(stepx)
					(stepy)
				)
				
		(set! angolo (/ 360 Points))
		(set! arco (* angolo (/ 3.14 180)))
		(set! alfa 0)
		(set! gcount 1)
		(set! npoint 2)
		(set! segment (cons-array 2 'double))   
		(set! stepx dx)
		(set! stepy dy)

;inizio delle operazioni che potranno essere annullate con un solo undo
	(gimp-undo-push-group-start inImage)	      
  
  (while (<= gcount Points) 
  	
  		(aset segment 0 (+ (* Radius (cos alfa)) stepx))
  		(aset segment 1 (+ (- (* Radius (sin alfa))) stepy))

		(gimp-pencil inLayer npoint segment )
		
  		(set! alfa (+ alfa arco))		
  		(set! gcount (+ gcount 1))
     	
   );end while

	(gimp-undo-push-group-end inImage) 
;fine delle operazioni che potranno essere annullate con un solo undo

	  (gimp-displays-flush)
	  
	);;let
) ;;def

(script-fu-register
 "script-fu-draw-circle-point"
 _"<Image>/_ATG/_Offset/Draw _circle-point"
 "Draw points in circle."
 "Arch. Giuseppe Conte <http://xoomer.alice.it/lwcon/>"
 "2007, Giuseppe Conte"
 "10 dicembre 2007 - San Pancrazio Salentino (BR) - Italy"
 "RGB* GRAY* INDEXED*"
 SF-IMAGE "The Image" 0
 SF-DRAWABLE "The Layer" 0
 SF-ADJUSTMENT "X center" '(0 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Y center" '(0 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Radius" '(100 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Number Point" '(10 0 9999 1 10 0 1)
)
